/*
 * This source file is part of KEOS (Free 3D Engine)
 * For the latest info, see http://www.keosengine.org/
 * E-mails : thierry.vouriot@keosengine.org, yeri@keosengine.org
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA, or go to
 * http://www.gnu.org/copyleft/lesser.txt.
 *
 */

#include "KeosGraphicString.h"
#include "KeosFontManager.h"

namespace Keos
{
    //=======================================================================
    // CGraphicString implementation
    //=======================================================================

    //-----------------------------------------------------------------------
    CGraphicString::CGraphicString(const TVector2I& StringPosition, const String& strText, const CColor& StringColor, 
                                    const String& strFont) :
    Position(StringPosition),
    Text    (strText),
    Color   (StringColor),
    Font    (strFont)
    {

    }

    //-----------------------------------------------------------------------
    void CGraphicString::Draw() const
    {
        CFontManager::Instance().DrawString(*this);
    }

    //-----------------------------------------------------------------------
    TVector2I CGraphicString::GetPixelSize() const
    {
        return CFontManager::Instance().GetStringPixelSize(*this);
    }

    //-----------------------------------------------------------------------
    void CGraphicString::Align(ulong nMode, const CRectangle& Rect)
    {
        // Size in pixels
        TVector2I PSize = GetPixelSize();

        // Horizontal alignement
        if (nMode & ALIGN_RIGHT)
        {
            Position.x = Rect.Right() - PSize.x;
        }
        else if (nMode & ALIGN_HCENTER)
        {
            Position.x = Rect.Left() + (Rect.Width() - PSize.x) / 2;
        }
        else // by default : ALIGN_LEFT
        {
            Position.x = Rect.Left();
        }

        // Vertical alignement
        if (nMode & ALIGN_BOTTOM)
        {
            Position.y = Rect.Bottom() - PSize.y;
        }
        else if (nMode & ALIGN_VCENTER)
        {
            Position.y = Rect.Top() + (Rect.Height() - PSize.y) / 2;
        }
        else // by default : ALIGN_TOP
        {
            Position.y = Rect.Top();
        }
    }

} // namespace Keos
